﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace WinformChart
{
	
	public partial class Form1 : Form
	{
		private readonly string SIN_SERIES = "sin";
		private readonly string COS_SERIES = "cos";

		private System.Timers.Timer timer = new System.Timers.Timer();

		public Form1()
		{
			InitializeComponent();
			InitInstance();
		}

		private void InitInstance()
		{
			chartControl.SetSeries(SIN_SERIES, System.Windows.Forms.DataVisualization.Charting.ChartValueType.DateTime);
			chartControl.SetChartType(SIN_SERIES, System.Windows.Forms.DataVisualization.Charting.SeriesChartType.FastLine);

			chartControl.SetSeries(COS_SERIES, System.Windows.Forms.DataVisualization.Charting.ChartValueType.DateTime);
			chartControl.SetChartType(COS_SERIES, System.Windows.Forms.DataVisualization.Charting.SeriesChartType.FastLine);

			timer.Interval = 10;
			timer.Elapsed += Timer_Elapsed;
			timer.Start();
		}

		private void AddValue(double value)
		{
			DateTime now = DateTime.Now;
			try
			{
				if (this.InvokeRequired)
				{
					this.Invoke(new MethodInvoker(() =>
					{
						chartControl.Add(SIN_SERIES, now, Math.Sin(value));
						chartControl.Add(COS_SERIES, now, Math.Cos(value));
					}));
				}
				else
				{
					chartControl.Add(SIN_SERIES, now, value);
					chartControl.Add(COS_SERIES, now, value);
				}
			}
			catch (Exception ex)
			{
				Debug.WriteLine(ex.Message);
			}
		}

		private void Timer_Elapsed(object sender, System.Timers.ElapsedEventArgs e)
		{
			AddValue((double)Environment.TickCount / 1000d);
		}

		private void Form1_FormClosing(object sender, FormClosingEventArgs e)
		{
			timer.Stop();
			chartControl = null;
		}
	}
}
